summaryrefslogtreecommitdiff
path: root/tests/dd/no-allocate.sh
diff options
context:
space:
mode:
authorOndrej Oprala <ooprala@redhat.com>2013-01-22 14:21:23 +0100
committerPádraig Brady <P@draigBrady.com>2013-04-14 01:00:45 +0100
commit8901e010fa24ba375d53e3e37fc7819621adcf19 (patch)
tree1f20f49bb0c455525b042e838462d4396c97a314 /tests/dd/no-allocate.sh
parent4114c93af398d7aecb5eb253f90d9b4cc0785643 (diff)
downloadcoreutils-8901e010fa24ba375d53e3e37fc7819621adcf19.tar.xz
dd: avoid buffer allocations unless needed
* src/dd.c: Add new static global variable ibuf. (alloc_ibuf, alloc_obuf): New functions factored from dd_copy(). (dd_copy): Call the new functions to allocate memory for ibuf and obuf when necessary. (skip): Likewise. * tests/dd/no-allocate.sh: New test. * tests/local.mk: Reference the test.
Diffstat (limited to 'tests/dd/no-allocate.sh')
-rwxr-xr-xtests/dd/no-allocate.sh53
1 files changed, 53 insertions, 0 deletions
diff --git a/tests/dd/no-allocate.sh b/tests/dd/no-allocate.sh
new file mode 100755
index 000000000..e45dd5cf9
--- /dev/null
+++ b/tests/dd/no-allocate.sh
@@ -0,0 +1,53 @@
+#!/bin/sh
+# make sure that dd doesn't allocate memory unnecessarily
+
+# Copyright (C) 2013 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ dd
+require_ulimit_
+
+# count and skip is zero, we don't need to allocate memory
+(ulimit -v 20000; dd bs=30M count=0) || fail=1
+(ulimit -v 20000; dd ibs=30M count=0) || fail=1
+(ulimit -v 20000; dd obs=30M count=0) || fail=1
+
+
+# Use a fifo for which seek fails, but read does not
+if mkfifo tape; then
+ # for non seekable output we need to allocate buffer when needed
+ echo 1 > tape&
+ (ulimit -v 20000; dd bs=30M skip=1 count=0 if=tape) && fail=1
+
+ echo 1 > tape&
+ (ulimit -v 20000; dd ibs=30M skip=1 count=0 if=tape) && fail=1
+
+ echo 1 > tape&
+ (ulimit -v 20000; dd obs=30M skip=1 count=0 if=tape) || fail=1
+
+
+ # for non seekable output we need to allocate buffer when needed
+ echo 1 > tape&
+ (ulimit -v 20000; dd bs=30M seek=1 count=0 of=tape) && fail=1
+
+ echo 1 > tape&
+ (ulimit -v 20000; dd obs=30M seek=1 count=0 of=tape) && fail=1
+
+ echo 1 > tape&
+ (ulimit -v 20000; dd ibs=30M seek=1 count=0 of=tape) || fail=1
+fi
+
+Exit $fail